// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: list_peers_by_id.sql

package queries

import (
	"context"

	"github.com/jackc/pgx/v5/pgtype"
)

const listPeersByID = `-- name: ListPeersByID :many

SELECT
    p.id,
    p.name,
    p.manager_address,
    -- coalesce is used to return an empty string if the value is null. the code generate by sqlc is unable to handle null values in this context.
    coalesce( STRING_AGG(pr.role::text, ', '),'')::text AS roles
FROM peers.peers as p
LEFT JOIN peers.peers_roles pr ON p.id = pr.peer_id
WHERE
    p.name IS NOT NULL AND
    p.manager_address IS NOT NULL AND
    (cardinality($1::varchar[]) = 0 OR p.id = ANY($1::varchar[]))
GROUP BY p.id
`

type ListPeersByIDRow struct {
	ID             string
	Name           pgtype.Text
	ManagerAddress pgtype.Text
	Roles          string
}

// Copyright © VNG Realisatie 2023
// Licensed under the EUPL
func (q *Queries) ListPeersByID(ctx context.Context, peerids []string) ([]*ListPeersByIDRow, error) {
	rows, err := q.db.Query(ctx, listPeersByID, peerids)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListPeersByIDRow{}
	for rows.Next() {
		var i ListPeersByIDRow
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.ManagerAddress,
			&i.Roles,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
